#ifndef FLYDESKTOPENTRYEDITDIALOG_H
#define FLYDESKTOPENTRYEDITDIALOG_H

#include <QDialog>

#include <fly/flyui_export.h>

class FlyDesktopEntryPropsWidget;

class FLYUI_EXPORT FlyDesktopEntryEditDialog : public QDialog
{
    Q_OBJECT
public:
    FlyDesktopEntryEditDialog(QWidget *parent = 0);
    ~FlyDesktopEntryEditDialog();

public slots:
    bool setDesktopEntryPath(const QString &path, bool create = false, const QString &pattern = QString());
    void setDesktopEntryCoords(int xx, int yy);
    void selectType(const QString& type);

    void accept() Q_DECL_OVERRIDE;

private slots:
    void copyFrom();
    void helpSlot();

private:
    FlyDesktopEntryPropsWidget *m_desktopEntryEditor;
    QString m_path;
    int m_x;
    int m_y;
    int m_isCoordsSet;
};

#endif
