#ifndef FLYICONBUTTON
#define FLYICONBUTTON

//#include <QToolButton>
#include <QPushButton>

#include <fly/flyui_export.h>

class FlyIconDialog;

class FLYUI_EXPORT FlyIconButton : public /*QTool*/QPushButton
{
    Q_OBJECT
    Q_PROPERTY(int defIconSize READ defaultIconSize WRITE setDefaultIconSize)

public:
    FlyIconButton(QWidget *parent = 0, int sz = 32);
    ~FlyIconButton();

    //return icon name without path and extension if it is in current theme, else - full path
    QString getIconNamePath() const
    {
        return icon;
    }
    QString getIconContext()  const
    {
        return context;
    }
    //set icon name without path and  extension if it is in current theme, else - full path
    //fastSample (usually NULL) is own initial icon to be set on button
    void setIconNamePath(const QString &nm, const QPixmap *fastSample = NULL);
    void setIconNamePath(const QString &nm, const QString &ctx, const QPixmap *fastSample = NULL);

    //set/get what icon size folder (if themes used) will be shown in FlyIconDialog
    void setDefaultIconSize(int sz);
    int  defaultIconSize();

signals:
    void iconChanged(const QString &);

protected slots:
    void chooseIcon();
    void setFullPathInDialog();

private:
    QString icon, context;
    QString iconPath;
    int     defIconSize;

    static FlyIconDialog *dialog;
    static int dialogRefCount;

    void getIconPathFromTheme();
    //void setFullPathInDialog();
};

#endif
