#ifndef FLYICONDIALOG
#define FLYICONDIALOG 1

#include <QDialog>
#include <QModelIndex>
#include <QFileIconProvider>

#include <fly/flyui_export.h>

namespace Ui
{
class iconDialog;
}

class FlyIconTheme;

class QFileSystemModel;
class QSettings;

class FlyIconDialogIconProvider : public QFileIconProvider
{
public:
    FlyIconDialogIconProvider(FlyIconTheme *th = NULL);
    ~FlyIconDialogIconProvider() {}

    QIcon icon(IconType type) const Q_DECL_OVERRIDE;
    QIcon icon(const QFileInfo &info) const Q_DECL_OVERRIDE;
    QString type(const QFileInfo &info) const Q_DECL_OVERRIDE;

private:
    FlyIconTheme *theme;
};

class FLYUI_EXPORT FlyIconDialog : public QDialog
{
    Q_OBJECT

public:
    FlyIconDialog(FlyIconTheme *th = NULL, int sz = 32, QWidget *parent = 0);
    ~FlyIconDialog();

    QString iconFilePath(); //get full path of selected icon
    QFileSystemModel *model(); //get model to setup filters, etc.

public slots:
    void updateButtons();

    void top();

    void activated(const QModelIndex &);
    void activatedByDoubleClick(const QModelIndex &);

    void setPath(const QString &); //set initial directory/file path

    void setDefaultIconSize(int sz);
    int  defaultIconSize();

private:
    void setConnections();
    void setCombo();

    FlyIconTheme *theme;
    FlyIconDialogIconProvider *iconProvider;
    QFileSystemModel *fsmodel;
    QSettings *s;
    int defIconSize;

    QModelIndex initialIndex;

    Ui::iconDialog *ui;
};

#endif
